<?php

namespace App\Service;

use Doctrine\ORM\QueryBuilder;
use Doctrine\ORM\Tools\Pagination\Paginator;

class Pagination
{
    protected readonly Paginator $paginator;

    public function __construct(
        protected readonly QueryBuilder $queryBuilder,
        protected readonly int $limit,
        protected readonly int $currentPage
    )
    {
        $this->paginator = new Paginator($this->queryBuilder);
    }

    public function getPaginator(): Paginator
    {
        return $this->paginator;
    }

    public function getTotal(): int
    {
        return $this->paginator->count();
    }

    public function getPages(): int
    {
        return ceil($this->paginator->count() / $this->limit);
    }

    public function getCurrentPage(): int
    {
        return $this->currentPage;
    }
}